diff -bruN freeswan-1.9.orig/pluto/dnskey.c freeswan-1.9/pluto/dnskey.c
--- freeswan-1.9.orig/pluto/dnskey.c	Sun Jan 28 16:03:03 2001
+++ freeswan-1.9/pluto/dnskey.c	Thu Jun  7 12:12:25 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: dnskey.c,v 1.18 2001/01/28 21:03:03 dhr Exp $
+ * RCSID $Id: dnskey.c,v 1.24 2001/04/09 19:48:40 dhr Exp $
  */
 
 #include <stdlib.h>
@@ -39,7 +39,8 @@
  * so we build some of our own :-(
  */
 
-static err_t do_dns_query(const struct id *id, int type, const char *typename);	/* forward */
+static err_t do_dns_query(const struct id *id, const struct id *peerid
+    , int type, const char *typename); /* forward */
 
 /* Support deprecated interface to allow for older releases of the resolver.
  * Fake new interface!
@@ -255,6 +256,14 @@
     return NULL;
 }
 
+static err_t
+eat_name_helpfully(pb_stream *pbs, const char *context)
+{
+    err_t ugh = eat_name(pbs);
+
+    return ugh == NULL? ugh
+       : builddiag("malformed name within DNS record of %s: %s", context, ugh);}
+
 /* non-variable part of 4.1.2 Question Section entry:
  *                                 1  1  1  1  1  1
  *   0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5
@@ -512,7 +521,7 @@
     return NULL;
 }
 
-/* info relevant for T_TXT */
+/* info relevant for T_TXT X-IPsec-Server */
 
 #define our_TXT_attr_string "X-IPsec-Server"
 static const char our_TXT_attr[] = our_TXT_attr_string;
@@ -530,11 +539,67 @@
 };
 
 static err_t
-accumulate_txt_rr(u_char *rdata, size_t rdlen, struct txt_tbl *tt)
+decode_iii(u_char **pp, const struct id *client_id, struct id *gw_id)
+{
+    u_char *p = *pp + strspn(*pp, " \t");
+    u_char *e = p + strcspn(p, " \t");
+    u_char under = *e;
+
+    if (p == e)
+       return "TXT " our_TXT_attr_string " badly formed (no gateway specified)";
+
+    *e = '\0';
+    if (*p == '@')
+    {
+       /* gateway specification in this record is @FQDN */
+       err_t ugh = atoid(p, gw_id);
+
+       if (ugh != NULL)
+           return builddiag("malformed FQDN in TXT " our_TXT_attr_string ": %s"
+               , ugh);
+    }
+    else
+    {
+       /* gateway specification is numeric */
+       ip_address ip;
+       err_t ugh = tnatoaddr(p, e-p
+           , strchr(p, ':') == NULL? AF_INET : AF_INET6
+           , &ip);
+
+       if (ugh != NULL)
+           return builddiag("malformed IP address in TXT " our_TXT_attr_string ": %s"
+               , ugh);
+
+       if (isanyaddr(&ip))
+           return "gateway address must not be 0.0.0.0 or 0::0";
+
+       iptoid(&ip, gw_id);
+    }
+
+    *e = under;
+    *pp = e + strspn(e, " \t");
+
+    DBG(DBG_CONTROL,
+       {
+           char cidb[IDTOA_BUF];
+           char pidb[IDTOA_BUF];
+
+           idtoa(client_id, cidb, sizeof(cidb));
+           idtoa(gw_id, pidb, sizeof(cidb));
+           DBG_log("decoding TXT %s record for %s: security gateway %s"
+               , our_TXT_attr, cidb, pidb);
+       });
+    return NULL;
+}
+
+static err_t
+accumulate_txt_rr(u_char *rdata, size_t rdlen, struct txt_tbl *tt
+, const struct id *client_id, const struct id *peer_id)
 {
     u_char str[2049];	/* space for unpacked RDATA */
     u_char *p = str;
     unsigned long pref = 0;
+    struct id sgw_id;
 
     {
 	err_t ugh = unpack_txt_rdata(str, sizeof(str), rdata, rdlen);
@@ -552,8 +617,10 @@
     p += sizeof(our_TXT_attr) - 1;	/* ignore our attribute name */
     p += strspn(p, " \t");	/* ignore leading whitespace */
 
-    /* decode optional '(' pref ')' */
-    if (*p == '(')
+    /* decode '(' pref ')' */
+    if (*p != '(')
+       return "X-IPsec-Server missing '('";
+
     {
 	char *e;
 
@@ -569,24 +636,57 @@
 
 	p++;
 	p += strspn(p, " \t");
+
+       if (pref > 0xFFFF)
+           return "X-IPsec-Server priority larger than 0xFFFF";
     }
 
     /* time for '=' */
 
-    if (*p == '=')
-    {
+    if (*p != '=')
+       return "X-IPsec-Server priority missing '='";
 
 	p++;
 	p += strspn(p, " \t");
 
+    /* Decode iii (Security Gateway ID).
+     * For simplicity, we don't save the decoded ID because
+     * we'd have to allocate memory for the strings in the id.
+     * (There are ways to excuse ourselves, but they are too tricky
+     * by half: the only time the ID would get used, it would only
+     * be an IP address.)
+     */
+    {
+       u_char *q = p;  /* so p isn't updated */
+       err_t ugh = decode_iii(&q, client_id, &sgw_id);
+
+       if (ugh != NULL)
+           return ugh;
+
+	if (peer_id == NULL)
+	{
+           /* we're looking for a gateway spec with an IP address */
+           if (!id_is_ipaddr(&sgw_id))
+               return NULL;    /* we cannot use this record, but it isn't wrong */
+	}
+	else
+	{
+	    /* we're looking for a gatway spec that confirms what we were told */
+           if (!same_id(peer_id, &sgw_id))
+               return NULL;    /* we cannot use this record, but it isn't wrong */
+	}
+    }
+
 	if (tt->count == 0)
 	    tt->pref = pref;
+ 
 	if (tt->pref > pref)
 	{
 	    /* earlier accumulation trumped by this one */
 	    tt->count = 0;
 	    tt->pref = pref;
 	}
+ 
 	if (tt->pref == pref
 	&& tt->count < (int)elemsof(tt->rr))
 	{
@@ -597,7 +697,7 @@
 	    i->rdlen = rdlen;
 	    i->offset = p - str;
 	}
-    }
+
     return NULL;
 }
 
@@ -610,10 +710,13 @@
  * Entries must not be freed without first clearing out references
  * from struct connection objects.
  */
-struct gw_info *gateways = NULL;
+static struct gw_info *gateways = NULL;
 
-/* process TXT record of remote client to discover its Security Gatway.
- * Format of body (what we get): a.b.c.d kkk
+/* process TXT X-IPsec-Server record of remote client to discover its
+ * Security Gatway.
+ * Format of body (the part we get): iii kkk
+ * where iii is @FQDN or dotted-decimal IPv4 address or colon-hex IPv6 address
+ * and kkk is an optional RSA public signing key in base 64.
  * Side effect: result is added at front of gateways list.
  * NOTE: we've got to be very wary of anything we find -- bad guys
  * might have prepared it.
@@ -628,7 +731,7 @@
     u_char *p;
     err_t ugh;
 
-    memset(&gi, 0, sizeof(gi));
+    zero(&gi);
 
     gi.client_id = *id;	/* will need to unshare_id_content */
 
@@ -638,58 +741,24 @@
 
     p = str + rri->offset;
 
-    /* decode a.b.c.d (or IPv6 equivalent) */
-    {
-	u_char *e = p + strcspn(p, " \t");
-	u_char under;
-
-	if (p == e)
-	    return "TXT " our_TXT_attr_string " badly formed (no separator)";
+    /* decode iii */
 
-	under = *e;
-	*e = '\0';
-	ugh = tnatoaddr(p, e-p
-	    , strchr(p, ':') == NULL? AF_INET : AF_INET6
-	    , &gi.gw);
-	*e = under;
+    ugh = decode_iii(&p, id, &gi.gw_id);
 	if (ugh != NULL)
-	    return ugh;	/* ??? more context would be nice */
-
-	if (isanyaddr(&gi.gw))
-	    return "gateway address must not be 0.0.0.0 or 0::0";
-
-	DBG(DBG_CONTROL,
-	    {
-		char cidb[IDTOA_BUF];
-
-		idtoa(id, cidb, sizeof(cidb));
-		DBG_log("decoding TXT %s record for %s: server %s"
-		    , our_TXT_attr, cidb, ip_str(&gi.gw));
-	    });
+       return ugh;
 
-	p = e + strspn(e, " \t");
-    }
+    if (!id_is_ipaddr(&gi.gw_id))
+       return "IP address for security gateway not specified in TXT record";
 
-    /* decode key */
+    /* decode optional key */
 
-    if (*p == '@')
+    if (*p == '\0')
     {
-	/* kkk is @hhh form */
-	struct id hhh;	/* id from TXT record -- not necessarily the host */
-	const struct RSA_public_key *pk;
-
-	/* decode the @dns.  It is *very* convenient that the '@' is there.
-	 * ??? the name will be searched in our domains!
-	 *     What is the best cure?  Trailling "." screws up numeric form.
-	 */
-	ugh = atoid(p, &hhh);
-	if (ugh != NULL)
-	    return ugh;
-
-	/* look for a key for hhh.
+        /* kkk is missing: go for gateway's KEY record (Gateway id is iii).
 	 * Beware: this is recursive!
 	 */
-	pk = get_RSA_public_key(&hhh);
+	const struct RSA_public_key *pk = get_RSA_public_key(&gi.gw_id);
+
 	if (pk == NULL)
 	    return "no RSA public key found";
 
@@ -701,18 +770,17 @@
     else
     {
 	/* kkk is base 64 encoding of key */
-	passert(p - str >= 2);	/* must be room for "0s" prefix */
-	*--p = 's';	    /* add "0s" prefix */
-	*--p = '0';
-	ugh = atobytes(p, 0, kb, sizeof(kb), &kbc.len);
+        ugh = ttodata(p, 0, 64, kb, sizeof(kb), &kbc.len);
+
 	if (ugh != NULL)
-	    return ugh;	/* ??? more context would be nice */
+	  return builddiag("malformed key data: %s", ugh);
+
 	passert(kbc.len < sizeof(kb));
 
 	kbc.ptr = kb;
 	ugh = unpack_RSA_public_key(&gi.gw_key, &kbc);
 	if (ugh != NULL)
-	    return ugh;	/* ??? more context would be nice */
+	  return builddiag("invalid key data: %s", ugh);
     }
 
     /* we're home free!  Allocate everything and add to gateways list. */
@@ -726,7 +794,8 @@
 }
 
 static err_t
-process_dns_answer(const struct id *id, u_char ans[], int anslen, int type)
+process_dns_answer(const struct id *id, const struct id *sgw_id
+, u_char ans[], int anslen, int type)
 {
     int r;	/* all-purpose return value holder */
     u_int16_t c;	/* number of current RR in current answer section */
@@ -734,7 +803,7 @@
     pb_stream pbs;
     struct qr_header qr_header;
     chunk_t key;	/* info relevant to T_KEY */
-    struct txt_tbl txt_tbl;	/* info relevant to T_TXT */
+    struct txt_tbl txt_tbl;	/* info relevant to T_TXT X-IPsec-Server */
 
     setchunk(key, NULL, 0);	/* empty */
     txt_tbl.count = 0;	/* empty */
@@ -794,7 +863,7 @@
     {
 	struct qs_fixed qsf;
 
-	ugh = eat_name(&pbs);
+	ugh = eat_name_helpfully(&pbs, "Query Section");
 	if (ugh != NULL)
 	    return ugh;
 
@@ -819,7 +888,7 @@
 
 	/* ??? do we need to match the name? */
 
-	ugh = eat_name(&pbs);
+	ugh = eat_name_helpfully(&pbs, "Answer Section");
 	if (ugh != NULL)
 	    return ugh;
 
@@ -841,7 +910,7 @@
 		ugh = process_key_rr(pbs.cur, tail, &key);
 		break;
 	    case T_TXT:
-		ugh = accumulate_txt_rr(pbs.cur, tail, &txt_tbl);
+                ugh = accumulate_txt_rr(pbs.cur, tail, &txt_tbl, id, sgw_id);
 		break;
 	    default:
 		passert(FALSE);
@@ -859,7 +928,7 @@
 	struct rr_fixed rrf;
 	size_t tail;
 
-	ugh = eat_name(&pbs);
+	ugh = eat_name_helpfully(&pbs, "Authority Section");
 	if (ugh != NULL)
 	    return ugh;
 
@@ -883,7 +952,7 @@
 	struct rr_fixed rrf;
 	size_t tail;
 
-	ugh = eat_name(&pbs);
+	ugh = eat_name_helpfully(&pbs, "Additional Section");
 	if (ugh != NULL)
 	    return ugh;
 
@@ -919,6 +988,7 @@
 
 	/* Note: quality of rand() matters hardly at all in this case */
 	return process_ipsec_server_rr(id, &txt_tbl.rr[rand() % txt_tbl.count]);
+	break;
 
     default:
 	passert(FALSE);
@@ -926,11 +996,22 @@
     return NULL;
 }
 
-/* look up a TXT or KEY record
+/* Look up a TXT X-IPsec-Server or KEY record.
+ * Three kinds of queries are supported:
+ * For KEY record, the result is a new entry in the public key table.
+ * For TXT records, the result is a new gateway entry.
+ * If sgw_id is null, only pay attention to TXT records that specify an
+ * IP address for the gatway: we need this in the initiation case.
+ * If sgw_id is non-null, only pay attention to TXT records that specify
+ * this id as the security gatway; this is useful to the Responder
+ * for confirming claims of gateways.
  * Beware: this can be recursive.
  */
 static err_t
-do_dns_query(const struct id *id, int type, const char *typename)
+do_dns_query(const struct id *id       /* domain to query */
+, const struct id *sgw_id      /* if non-null, any accepted gw_info must match */
+, int type     /* T_TXT or T_KEY, selecting rr type of interest */
+, const char *typename)        /* string for type */
 {
     err_t ugh;
     u_char name_buf[NS_MAXDNAME + 1];
@@ -952,53 +1033,74 @@
 	 * That might be better, but older resolvers don't.
 	 * See resolver(3), if you have it.
 	 */
-	return hstrerror(h_errno);
+	return builddiag("failure querying DNS for %s of %s: %s"
+           , typename, name_buf, hstrerror(h_errno));
     }
 
     if (anslen > (int) sizeof(ans))
-	return "(internal error) answer too long for buffer";
+       return "(INTERNAL ERROR) answer too long for buffer";
+
+    ugh = process_dns_answer(id, sgw_id, ans, anslen, type);
+    if (ugh != NULL)
+       return builddiag("failure processing %s record of DNS answer for %s: %s"
+           , typename, name_buf, ugh);
 
-    return process_dns_answer(id, ans, anslen, type);
+    return NULL;
 }
 
-/* look up KEY record, if any, for a suitable RSA key */
+/* look up DNS KEY RR, if any, for id to find a suitable RSA key */
 err_t
 fetch_public_key(const struct id *id)
 {
-    return do_dns_query(id, T_KEY, "KEY");
+    return do_dns_query(id, (struct id *)NULL, T_KEY, "KEY");
 }
 
-/* look up TXT record, if any.
+/* look up TXT X-IPsec-Server record, if any.
  * Will tell us GW IP address and public RSA key.
- * On success, the result will be the first entry in the gateways list.
+ * On success, the result will be assigned to *gwp.
  * Note: the key is being ascribed to the gateway by the client.
  *   The gateway may not agree!  So we cannot trust it in other
  *   contexts.
  */
 err_t
-discover_gateway(const ip_address *peer_client)
+discover_gateway(const ip_address *peer_client
+, const struct id *putative_sgw
+, struct gw_info **gwp)
 {
     struct id id;
-    struct gw_info
-	**pp,
-	*p;
+    struct gw_info **pp
+       , *p;
+    err_t ugh = NULL;
 
-    memset(&id, 0, sizeof(id));
-    id.kind = aftoinfo(addrtypeof(peer_client))->id_addr;
-    id.ip_addr = *peer_client;
+    iptoid(peer_client, &id);
 
-    for (pp = &gateways; (p = *pp) != NULL; pp = &p->next)
+    for (pp = &gateways; ; pp = &p->next)
     {
-	if (same_id(&id, &p->client_id))
+       p = *pp;
+       if (p == NULL)
+       {
+           /* not in table: do a DNS query.
+            * On success, will leave result at front of gateways.
+            */
+           ugh = do_dns_query(&id, putative_sgw, T_TXT, "TXT");
+           break;
+       }
+       if (same_id(&id, &p->client_id)
+       && (putative_sgw == NULL? id_is_ipaddr(&p->gw_id) : same_id(putative_sgw, &p->gw_id)))
 	{
 	    /* We found one from a previous attempt.
-	     * Move it to front of gateways list; return.
+	     * Move it to front of gateways list.
 	     */
 	    *pp = p->next;
 	    p->next = gateways;
 	    gateways = p;
-	    return NULL;
+	    break;
 	}
     }
-    return do_dns_query(&id, T_TXT, "TXT");
+
+    /* if successful and requested, set *gwp from front of gateways */
+    if (ugh == NULL && gwp != NULL)
+       *gwp = gateways;
+
+    return ugh;
 }
diff -bruN freeswan-1.9.orig/pluto/dnskey.h freeswan-1.9/pluto/dnskey.h
--- freeswan-1.9.orig/pluto/dnskey.h	Sun Jan 28 16:03:03 2001
+++ freeswan-1.9/pluto/dnskey.h	Tue Jun  5 15:48:15 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: dnskey.h,v 1.9 2001/01/28 21:03:03 dhr Exp $
+ * RCSID $Id: dnskey.h,v 1.12 2001/02/26 23:21:30 dhr Exp $
  */
 
 extern err_t fetch_public_key(const struct id *id);
@@ -22,13 +22,14 @@
 	, last_tried_time
 	, last_worked_time;
 #define NO_TIME ((time_t) -2)	/* time_t value meaning "not_yet" */
-    struct id client_id;	/* of peer */
-    ip_address gw;	/* peer */
+    struct id client_id;       /* id of client of peer */
+    struct id gw_id;   /* id of peer (if id_is_ipaddr, .ip_addr is address) */
     struct RSA_public_key gw_key;
     struct gw_info *next;
 };
 
-extern struct gw_info *gateways;	/* list of discovered gateways */
-
-/* find a new gateway; add it to front of list */
-extern err_t discover_gateway(const ip_address *peer_client);
+/* find a new gateway */
+extern err_t
+    discover_gateway(const ip_address *peer_client
+       , const struct id *putative_sgw
+       , struct gw_info **gwp);
diff -bruN freeswan-1.9.orig/pluto/g10_dsa.c freeswan-1.9/pluto/g10_dsa.c
--- freeswan-1.9.orig/pluto/g10_dsa.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/g10_dsa.c	Wed May 16 10:57:20 2001
@@ -0,0 +1,476 @@
+/* g10_dsa.c  -  DSA signature scheme
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GnuPG.
+ *
+ * GnuPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GnuPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#ifdef PLUTO
+#include <gmp.h>
+#include <freeswan.h>
+#include "constants.h"
+#include "defs.h"
+#include "log.h"
+#include "rnd.h"
+#include "gcryptfix.h"
+#else /*! PLUTO */
+/* #include <config.h> */
+#endif /* !PLUTO */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#ifndef PLUTO
+/* #include <assert.h> */
+/* #include "util.h" */
+/* #include "mpi.h" */
+/* #include "cipher.h" */
+#endif
+
+#include "g10_dsa.h"
+
+typedef struct {
+    MPI p;	    /* prime */
+    MPI q;	    /* group order */
+    MPI g;	    /* group generator */
+    MPI y;	    /* g^x mod p */
+} DSA_public_key;
+
+
+typedef struct {
+    MPI p;	    /* prime */
+    MPI q;	    /* group order */
+    MPI g;	    /* group generator */
+    MPI y;	    /* g^x mod p */
+    MPI x;	    /* secret exponent */
+} DSA_secret_key;
+
+
+static MPI gen_k( MPI q );
+static void test_keys( DSA_secret_key *sk, unsigned qbits );
+static int  check_secret_key( DSA_secret_key *sk );
+static void generate( DSA_secret_key *sk, unsigned nbits, MPI **ret_factors );
+static void sign(MPI r, MPI s, MPI input, DSA_secret_key *skey);
+static int  verify(MPI r, MPI s, MPI input, DSA_public_key *pkey);
+
+static void
+progress( int c )
+{
+    fputc( c, stderr );
+}
+
+
+/****************
+ * Generate a random secret exponent k less than q
+ */
+static MPI
+gen_k( MPI q )
+{
+    MPI k = mpi_alloc_secure( mpi_get_nlimbs(q) );
+    unsigned int nbits = mpi_get_nbits(q);
+    unsigned int nbytes = (nbits+7)/8;
+    char *rndbuf = NULL;
+
+    if( DBG_CIPHER )
+	log_debug("choosing a random k ");
+    for(;;) {
+	if( DBG_CIPHER )
+	    progress('.');
+
+	if( !rndbuf || nbits < 32 ) {
+	    m_free(rndbuf);
+	    rndbuf = get_random_bits( nbits, 1, 1 );
+	}
+	else { /* change only some of the higher bits */
+	    /* we could imporove this by directly requesting more memory
+	     * at the first call to get_random_bits() and use this the here
+	     * maybe it is easier to do this directly in random.c */
+	    char *pp = get_random_bits( 32, 1, 1 );
+	    memcpy( rndbuf,pp, 4 );
+	    m_free(pp);
+	}
+	mpi_set_buffer( k, rndbuf, nbytes, 0 );
+	if( mpi_test_bit( k, nbits-1 ) )
+	    mpi_set_highbit( k, nbits-1 );
+	else {
+	    mpi_set_highbit( k, nbits-1 );
+	    mpi_clear_bit( k, nbits-1 );
+	}
+
+	if( !(mpi_cmp( k, q ) < 0) ) {	/* check: k < q */
+	    if( DBG_CIPHER )
+		progress('+');
+	    continue; /* no  */
+	}
+	if( !(mpi_cmp_ui( k, 0 ) > 0) ) { /* check: k > 0 */
+	    if( DBG_CIPHER )
+		progress('-');
+	    continue; /* no */
+	}
+	break;	/* okay */
+    }
+    m_free(rndbuf);
+    if( DBG_CIPHER )
+	progress('\n');
+
+    return k;
+}
+
+
+static void
+test_keys( DSA_secret_key *sk, unsigned qbits )
+{
+    DSA_public_key pk;
+    MPI test = mpi_alloc( qbits / BITS_PER_MPI_LIMB );
+    MPI out1_a = mpi_alloc( qbits / BITS_PER_MPI_LIMB );
+    MPI out1_b = mpi_alloc( qbits / BITS_PER_MPI_LIMB );
+
+    pk.p = sk->p;
+    pk.q = sk->q;
+    pk.g = sk->g;
+    pk.y = sk->y;
+    /*mpi_set_bytes( test, qbits, get_random_byte, 0 );*/
+    {	char *p = get_random_bits( qbits, 0, 0 );
+	mpi_set_buffer( test, p, (qbits+7)/8, 0 );
+	m_free(p);
+    }
+
+    sign( out1_a, out1_b, test, sk );
+    if( !verify( out1_a, out1_b, test, &pk ) )
+	log_fatal("DSA:: sign, verify failed\n");
+
+    mpi_free( test );
+    mpi_free( out1_a );
+    mpi_free( out1_b );
+}
+
+
+
+/****************
+ * Generate a DSA key pair with a key of size NBITS
+ * Returns: 2 structures filled with all needed values
+ *	    and an array with the n-1 factors of (p-1)
+ */
+static void
+generate( DSA_secret_key *sk, unsigned nbits, MPI **ret_factors )
+{
+    MPI p;    /* the prime */
+    MPI q;    /* the 160 bit prime factor */
+    MPI g;    /* the generator */
+    MPI y;    /* g^x mod p */
+    MPI x;    /* the secret exponent */
+    MPI h, e;  /* helper */
+    unsigned qbits;
+    byte *rndbuf;
+
+    assert( nbits >= 512 && nbits <= 1024 );
+
+    qbits = 160;
+    p = generate_elg_prime( 1, nbits, qbits, NULL, ret_factors );
+    /* get q out of factors */
+    q = mpi_copy((*ret_factors)[0]);
+    if( mpi_get_nbits(q) != qbits )
+	BUG();
+
+    /* find a generator g (h and e are helpers)*/
+    /* e = (p-1)/q */
+    e = mpi_alloc( mpi_get_nlimbs(p) );
+    mpi_sub_ui( e, p, 1 );
+    mpi_fdiv_q( e, e, q );
+    g = mpi_alloc( mpi_get_nlimbs(p) );
+    h = mpi_alloc_set_ui( 1 ); /* we start with 2 */
+    do {
+	mpi_add_ui( h, h, 1 );
+	/* g = h^e mod p */
+	mpi_powm( g, h, e, p );
+    } while( !mpi_cmp_ui( g, 1 ) );  /* continue until g != 1 */
+
+    /* select a random number which has these properties:
+     *	 0 < x < q-1
+     * This must be a very good random number because this
+     * is the secret part. */
+    if( DBG_CIPHER )
+	log_debug("choosing a random x ");
+    assert( qbits >= 160 );
+    x = mpi_alloc_secure( mpi_get_nlimbs(q) );
+    mpi_sub_ui( h, q, 1 );  /* put q-1 into h */
+    rndbuf = NULL;
+    do {
+	if( DBG_CIPHER )
+	    progress('.');
+	if( !rndbuf )
+	    rndbuf = get_random_bits( qbits, 2, 1 );
+	else { /* change only some of the higher bits (= 2 bytes)*/
+	    char *r = get_random_bits( 16, 2, 1 );
+	    memcpy(rndbuf, r, 16/8 );
+	    m_free(r);
+	}
+	mpi_set_buffer( x, rndbuf, (qbits+7)/8, 0 );
+	mpi_clear_highbit( x, qbits+1 );
+    } while( !( mpi_cmp_ui( x, 0 )>0 && mpi_cmp( x, h )<0 ) );
+    m_free(rndbuf);
+    mpi_free( e );
+    mpi_free( h );
+
+    /* y = g^x mod p */
+    y = mpi_alloc( mpi_get_nlimbs(p) );
+    mpi_powm( y, g, x, p );
+
+    if( DBG_CIPHER ) {
+	progress('\n');
+	log_mpidump("dsa  p= ", p );
+	log_mpidump("dsa  q= ", q );
+	log_mpidump("dsa  g= ", g );
+	log_mpidump("dsa  y= ", y );
+	log_mpidump("dsa  x= ", x );
+    }
+
+    /* copy the stuff to the key structures */
+    sk->p = p;
+    sk->q = q;
+    sk->g = g;
+    sk->y = y;
+    sk->x = x;
+
+    /* now we can test our keys (this should never fail!) */
+    test_keys( sk, qbits );
+}
+
+
+
+/****************
+ * Test whether the secret key is valid.
+ * Returns: if this is a valid key.
+ */
+static int
+check_secret_key( DSA_secret_key *sk )
+{
+    int rc;
+    MPI y = mpi_alloc( mpi_get_nlimbs(sk->y) );
+
+    mpi_powm( y, sk->g, sk->x, sk->p );
+    rc = !mpi_cmp( y, sk->y );
+    mpi_free( y );
+    return rc;
+}
+
+
+
+/****************
+ * Make a DSA signature from HASH and put it into r and s.
+ */
+
+static void
+sign(MPI r, MPI s, MPI hash, DSA_secret_key *skey )
+{
+    MPI k;
+    MPI kinv;
+    MPI tmp;
+
+    /* select a random k with 0 < k < q */
+    k = gen_k( skey->q );
+
+    /* r = (a^k mod p) mod q */
+    mpi_powm( r, skey->g, k, skey->p );
+    mpi_fdiv_r( r, r, skey->q );
+
+    /* kinv = k^(-1) mod q */
+    kinv = mpi_alloc( mpi_get_nlimbs(k) );
+    mpi_invm(kinv, k, skey->q );
+
+    /* s = (kinv * ( hash + x * r)) mod q */
+    tmp = mpi_alloc( mpi_get_nlimbs(skey->p) );
+    mpi_mul( tmp, skey->x, r );
+    mpi_add( tmp, tmp, hash );
+    mpi_mulm( s , kinv, tmp, skey->q );
+
+    mpi_free(k);
+    mpi_free(kinv);
+    mpi_free(tmp);
+}
+
+
+/****************
+ * Returns true if the signature composed from R and S is valid.
+ */
+static int
+verify(MPI r, MPI s, MPI hash, DSA_public_key *pkey )
+{
+    int rc;
+    MPI w, u1, u2, v;
+    MPI base[3];
+    MPI exp[3];
+
+
+    if( !(mpi_cmp_ui( r, 0 ) > 0 && mpi_cmp( r, pkey->q ) < 0) )
+	return 0; /* assertion	0 < r < q  failed */
+    if( !(mpi_cmp_ui( s, 0 ) > 0 && mpi_cmp( s, pkey->q ) < 0) )
+	return 0; /* assertion	0 < s < q  failed */
+
+    w  = mpi_alloc( mpi_get_nlimbs(pkey->q) );
+    u1 = mpi_alloc( mpi_get_nlimbs(pkey->q) );
+    u2 = mpi_alloc( mpi_get_nlimbs(pkey->q) );
+    v  = mpi_alloc( mpi_get_nlimbs(pkey->p) );
+
+    /* w = s^(-1) mod q */
+    mpi_invm( w, s, pkey->q );
+
+    /* u1 = (hash * w) mod q */
+    mpi_mulm( u1, hash, w, pkey->q );
+
+    /* u2 = r * w mod q  */
+    mpi_mulm( u2, r, w, pkey->q );
+
+    /* v =  g^u1 * y^u2 mod p mod q */
+    base[0] = pkey->g; exp[0] = u1;
+    base[1] = pkey->y; exp[1] = u2;
+    base[2] = NULL;    exp[2] = NULL;
+    mpi_mulpowm( v, base, exp, pkey->p );
+    mpi_fdiv_r( v, v, pkey->q );
+
+    rc = !mpi_cmp( v, r );
+
+    mpi_free(w);
+    mpi_free(u1);
+    mpi_free(u2);
+    mpi_free(v);
+    return rc;
+}
+
+
+/*********************************************
+ **************  interface  ******************
+ *********************************************/
+
+int
+dsa_generate( int algo, unsigned nbits, MPI *skey, MPI **retfactors )
+{
+    DSA_secret_key sk;
+
+    if( algo != PUBKEY_ALGO_DSA )
+	return G10ERR_PUBKEY_ALGO;
+
+    generate( &sk, nbits, retfactors );
+    skey[0] = sk.p;
+    skey[1] = sk.q;
+    skey[2] = sk.g;
+    skey[3] = sk.y;
+    skey[4] = sk.x;
+    return 0;
+}
+
+
+int
+dsa_check_secret_key( int algo, MPI *skey )
+{
+    DSA_secret_key sk;
+
+    if( algo != PUBKEY_ALGO_DSA )
+	return G10ERR_PUBKEY_ALGO;
+    if( !skey[0] || !skey[1] || !skey[2] || !skey[3] || !skey[4] )
+	return G10ERR_BAD_MPI;
+
+    sk.p = skey[0];
+    sk.q = skey[1];
+    sk.g = skey[2];
+    sk.y = skey[3];
+    sk.x = skey[4];
+    if( !check_secret_key( &sk ) )
+	return G10ERR_BAD_SECKEY;
+
+    return 0;
+}
+
+
+
+int
+dsa_sign( int algo, MPI *resarr, MPI data, MPI *skey )
+{
+    DSA_secret_key sk;
+
+    if( algo != PUBKEY_ALGO_DSA )
+	return G10ERR_PUBKEY_ALGO;
+    if( !data || !skey[0] || !skey[1] || !skey[2] || !skey[3] || !skey[4] )
+	return G10ERR_BAD_MPI;
+
+    sk.p = skey[0];
+    sk.q = skey[1];
+    sk.g = skey[2];
+    sk.y = skey[3];
+    sk.x = skey[4];
+    resarr[0] = mpi_alloc( mpi_get_nlimbs( sk.p ) );
+    resarr[1] = mpi_alloc( mpi_get_nlimbs( sk.p ) );
+    sign( resarr[0], resarr[1], data, &sk );
+    return 0;
+}
+
+int
+dsa_verify( int algo, MPI hash, MPI *data, MPI *pkey,
+		    int (*cmp)(void *, MPI) UNUSED, void *opaquev UNUSED)
+{
+    DSA_public_key pk;
+
+    if( algo != PUBKEY_ALGO_DSA )
+	return G10ERR_PUBKEY_ALGO;
+    if( !data[0] || !data[1] || !hash
+	|| !pkey[0] || !pkey[1] || !pkey[2] || !pkey[3] )
+	return G10ERR_BAD_MPI;
+
+    pk.p = pkey[0];
+    pk.q = pkey[1];
+    pk.g = pkey[2];
+    pk.y = pkey[3];
+    if( !verify( data[0], data[1], hash, &pk ) )
+	return G10ERR_BAD_SIGN;
+    return 0;
+}
+
+
+
+unsigned
+dsa_get_nbits( int algo, MPI *pkey )
+{
+    if( algo != PUBKEY_ALGO_DSA )
+	return 0;
+    return mpi_get_nbits( pkey[0] );
+}
+
+
+/****************
+ * Return some information about the algorithm.  We need algo here to
+ * distinguish different flavors of the algorithm.
+ * Returns: A pointer to string describing the algorithm or NULL if
+ *	    the ALGO is invalid.
+ * Usage: Bit 0 set : allows signing
+ *	      1 set : allows encryption
+ */
+const char *
+dsa_get_info( int algo, int *npkey, int *nskey, int *nenc, int *nsig,
+							 int *use )
+{
+    *npkey = 4;
+    *nskey = 5;
+    *nenc = 0;
+    *nsig = 2;
+
+    switch( algo ) {
+      case PUBKEY_ALGO_DSA:   *use = PUBKEY_USAGE_SIG; return "DSA";
+      default: *use = 0; return NULL;
+    }
+}
+
+
diff -bruN freeswan-1.9.orig/pluto/g10_dsa.h freeswan-1.9/pluto/g10_dsa.h
--- freeswan-1.9.orig/pluto/g10_dsa.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/g10_dsa.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,32 @@
+/* dsa.h  -  DSA signature scheme
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GnuPG.
+ *
+ * GnuPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GnuPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+#ifndef G10_DSA_H
+#define G10_DSA_H
+
+int dsa_generate( int algo, unsigned nbits, MPI *skey, MPI **retfactors );
+int dsa_check_secret_key( int algo, MPI *skey );
+int dsa_sign( int algo, MPI *resarr, MPI data, MPI *skey );
+int dsa_verify( int algo, MPI hash, MPI *data, MPI *pkey,
+		    int (*cmp)(void *, MPI), void *opaquev );
+unsigned dsa_get_nbits( int algo, MPI *pkey );
+const char *dsa_get_info( int algo, int *npkey, int *nskey,
+				    int *nenc, int *nsig, int *use );
+
+#endif /*G10_DSA_H*/
